import {ComponentType} from 'react'
import {JSX as JSX_2} from 'react/jsx-runtime'
import {ReactNode} from 'react'
import type {Syntax} from 'refractor'

/**
 * @public
 */
export declare const hasLanguage: (lang: string) => boolean

/**
 * @public
 */
export declare interface Marker {
  line: number
  className?: string
  component?: ReactNode | ComponentType<MarkerProps>
}

/**
 * @public
 */
export declare interface MarkerProps {
  className: string
  markers: (Marker | number)[]
  children?: ReactNode
}

/**
 * @public
 */
export declare function Refractor(props: RefractorProps): JSX_2.Element

/**
 * @public
 */
export declare interface RefractorProps {
  value: string
  language: string
  className?: string
  inline?: boolean
  markers?: (Marker | number)[]
}

/**
 * @public
 */
export declare const registerLanguage: (lang: Syntax) => void

export {}
